/*
 *	main.c
 *
 *	G~[^[main
 *
 *	* Tue Nov 28 06:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

//#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#include "instdef.c"
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

//#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
//#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/* XvCg`BKvɉăCN[hĂBsprite.h̕ҏWKvłB */
//#include "sprite.h"
//#define DEFINE_SPRITE
//#include "sprite.h"
//#undef  DEFINE_SPRITE

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		(EMU_FPS / (EMU_SKIP + 1))	/* t[[g */
#define SEC(s)		((int)(FPS * (s)))		/* b->t[ϊ */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

//extern const unsigned char PAT[];
//extern const unsigned char BG[];
//TEXTURE pat;
//TEXTURE bg;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
void run();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	run();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_MUSIC
	/* yCu܂B */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

/*{{AvP[VL̏*/
	turbo(7); /* 48MHz/1WAIT */
	//srand(pceTimerGetCount());
	/* rbg}bvB */
	//texture_init(&pat, PAT);
	//texture_init(&bg, BG);
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR0	0x130		/* PAUSEJ[(wip) */
#define PAUSE_COLOR1	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(/*joy & TRG_START*/0) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, color_table[0] ? PAUSE_COLOR1 : PAUSE_COLOR0);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR0
#undef PAUSE_COLOR1
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	galxwars
 ****************************************************************************/

static const ROM rom_galxwars[] = {
	{ "univgw3.0", 0x0000, 0x0400, 0x937796f4 },
	{ "univgw4.1", 0x0400, 0x0400, 0x4b86e7a6 },
	{ "univgw5.2", 0x0800, 0x0400, 0x47a187cd },
	{ "univgw6.3", 0x0c00, 0x0400, 0x7b7d22ff },
	{ "univgw1.4", 0x4000, 0x0400, 0x0871156e },
	{ "univgw2.5", 0x4400, 0x0400, 0x6036d7bf },
	{ NULL/*I[*/ },
};

static void
init_galxwars(EMU* emu)
{
	emu->port[0] = 0x40;

	// Lives	00	2
	//		01*	3
	//		02	4
	//		03	5
	// Unknown	00*	On
	//		04	Off
	// Bonus Life	00*	3000
	//		08	5000
	// Coinage	00*	1C_1C
	//		80	2C_1C
	emu->port[2] = 0x01;
}

static void
update_input_galxwars(EMU* emu)
{
	unsigned char input = 0x80;

	if(!(joy & PAD_SELECT)) input |= 0x01;
	if(  joy & PAD_START  ) input |= 0x04;
	if(  joy & PAD_A      ) input |= 0x10;
	if(  joy & PAD_DN     ) input |= 0x20;
	if(  joy & PAD_UP     ) input |= 0x40;

	emu->port[1] = input;
}

static const GAME game_galxwars = {
	"MNV[EH[Y",
	"galxwars.zip",
	rom_galxwars,
	init_galxwars,
	update_input_galxwars,
};

/****************************************************************************
 *	invadpt2
 ****************************************************************************/

static const ROM rom_invadpt2[] = {
	/* vOROM */
	{ "pv.01", 0x0000, 0x0800, 0x7288a511 },
	{ "pv.02", 0x0800, 0x0800, 0x097dd8d5 },
	{ "pv.03", 0x1000, 0x0800, 0x1766337e },
	{ "pv.04", 0x1800, 0x0800, 0x8f0e62e0 },
	{ "pv.05", 0x4000, 0x0800, 0x19b505e9 },
	/* J[ROM */
	//{ "pv06_1.bin", 0x0000, 0x0400, 0xa732810b },
	//{ "pv07_2.bin", 0x0400, 0x0400, 0x2c5b91cb },
	{ NULL/*I[*/ },
};

static void
init_invadpt2(EMU* emu)
{
	emu->port[0] = 0x40;

	// Lives			00*	3
	//				01	4
	// Unknown			00*	Off
	//				02	On
	// High Score Preset Mode	00*	Off
	//				08	On
	// Coin Info			00*	On
	//				80	Off
	emu->port[2] = 0x00;
}

static void
update_input_invadpt2(EMU* emu)
{
	unsigned char input = 0x80;

	if(!(joy & PAD_SELECT)) input |= 0x01;
	if(  joy & PAD_START  ) input |= 0x04;
	if(  joy & PAD_A      ) input |= 0x10;
	if(  joy & PAD_DN     ) input |= 0x20;
	if(  joy & PAD_UP     ) input |= 0x40;

	emu->port[1] = input;
}

static const GAME game_invadpt2 = {
	"߰ްް߰II",
	"invadpt2.zip",
	rom_invadpt2,
	init_invadpt2,
	update_input_invadpt2,
};

/****************************************************************************
 *	lupin3
 ****************************************************************************/

static const ROM rom_lupin3[] = {
	{ "lp12.bin", 0x0000, 0x0800, 0x68a7f47a },
	{ "lp13.bin", 0x0800, 0x0800, 0xcae9a17b },
	{ "lp14.bin", 0x1000, 0x0800, 0x3553b9e4 },
	{ "lp15.bin", 0x1800, 0x0800, 0xacbeef64 },
	{ "lp16.bin", 0x4000, 0x0800, 0x19fcdc54 },
	{ "lp17.bin", 0x4800, 0x0800, 0x66289ab2 },
	{ "lp18.bin", 0x5000, 0x0800, 0x2f07b4ba },
	{ NULL/*I[*/ },
};

static void
init_lupin3(EMU* emu)
{
	emu->port[0] = 0x00;

	// Lives		00*	3
	//			01	4
	//			02	5
	//			03	6
	// Cabinet		00*	Upright
	//			04	Cocktail
	// Bags to Collect	00*	8
	//			08	2
	// Language		00	English
	//			10*	Japanese
	// Invulnerability	00*	Off
	//			80	On
	//
	emu->port[2] = 0x10;
}

static void
update_input_lupin3(EMU* emu)
{
	unsigned char input = 0x00;

	if(!(joy & PAD_SELECT)) input |= 0x01;
	if(  joy & PAD_START  ) input |= 0x04;
	if(  joy & PAD_A      ) input |= 0x08;
	if(  joy & PAD_UP     ) input |= 0x10;
	if(  joy & PAD_RI     ) input |= 0x20;
	if(  joy & PAD_DN     ) input |= 0x40;
	if(  joy & PAD_LF     ) input |= 0x80;

	emu->port[1] = input;
}

static const GAME game_lupin3 = {
	"pO",
	"lupin3.zip",
	rom_lupin3,
	init_lupin3,
	update_input_lupin3,
};

/****************************************************************************
 *	lrescue
 ****************************************************************************/

static const ROM rom_lrescue[] = {
	/* vOROM */
	{ "lrescue.1", 0x0000, 0x0800, 0x2bbc4778 },
	{ "lrescue.2", 0x0800, 0x0800, 0x49e79706 },
	{ "lrescue.3", 0x1000, 0x0800, 0x1ac969be },
	{ "lrescue.4", 0x1800, 0x0800, 0x782fee3c },
	{ "lrescue.5", 0x4000, 0x0800, 0x58fde8bc },
	{ "lrescue.6", 0x4800, 0x0800, 0xbfb0f65d },
	/* J[ROM */
	//{ "7643-1.cpu",0x0000, 0x0400, 0x8b2e38de },
	{ NULL/*I[*/ },
};

static void
init_lrescue(EMU* emu)
{
	emu->port[0] = 0x00;

	// Lives	00*	3
	//		01	4
	//		02	5
	//		03	6
	// Unknown	00*	On
	//		08	Off
	// Unknown	00*	On
	//		80	Off
	//
	emu->port[2] = 0x00;
}

static void
update_input_lrescue(EMU* emu)
{
	unsigned char input = 0x80;

	if(!(joy & PAD_SELECT)) input |= 0x01;
	if(  joy & PAD_START  ) input |= 0x04;
	if(  joy & PAD_A      ) input |= 0x10;
	if(  joy & PAD_DN     ) input |= 0x20;
	if(  joy & PAD_UP     ) input |= 0x40;

	emu->port[1] = input;
}

static const GAME game_lrescue = {
	"iXL[",
	"lrescue.zip",
	rom_lrescue,
	init_lrescue,
	update_input_lrescue,
};

/****************************************************************************
 *	ballbomb
 ****************************************************************************/

static const ROM rom_ballbomb[] = {
	/* vOROM */
	{ "tn01"  , 0x0000, 0x0800, 0x551585b5 },
	{ "tn02"  , 0x0800, 0x0800, 0x7e1f734f },
	{ "tn03"  , 0x1000, 0x0800, 0xd93e20bc },
	{ "tn04"  , 0x1800, 0x0800, 0xd0689a22 },
	{ "tn05-1", 0x4000, 0x0800, 0x5d5e94f1 },
	/* J[ROM */
	//{ "tn06"  , 0x0000, 0x0400, 0x7ec554c4 },
	//{ "tn07"  , 0x0400, 0x0400, 0xdeb0ac82 },
	{ NULL/*I[*/ },
};

static void
init_ballbomb(EMU* emu)
{
	emu->port[0] = 0x00;

	// Lives	00*	3
	//		01	4
	//		02	5
	//		03	6
	emu->port[2] = 0x00;
}

static void
update_input_ballbomb(EMU* emu)
{
	unsigned char input = 0x80;

	if(!(joy & PAD_SELECT)) input |= 0x01;
	if(  joy & PAD_START  ) input |= 0x04;
	if(  joy & PAD_A      ) input |= 0x10;
	if(  joy & PAD_DN     ) input |= 0x20;
	if(  joy & PAD_UP     ) input |= 0x40;

	emu->port[1] = input;
}

static const GAME game_ballbomb = {
	"o[{o[",
	"ballbomb.zip",
	rom_ballbomb,
	init_ballbomb,
	update_input_ballbomb,
};

/****************************************************************************
 *	run
 ****************************************************************************/

typedef struct _GAMELIST {
	const GAME* game;
	int avail;
} GAMELIST;
static GAMELIST gamelist[] = {
	{ &game_galxwars },
	{ &game_invadpt2 },
	{ &game_lupin3   },
	{ &game_lrescue  },
	{ &game_ballbomb },
};
#define NUM_GAMES	(sizeof gamelist / sizeof *gamelist)

void
run()
{
	int i, sel, color;
	FILEACC fa;
	GAMELIST* pgl;

	/* ROMZbgt@C̑݃`FbNB */
	for(i = 0; i < NUM_GAMES; i++) {
		pgl = &gamelist[i];
		pgl->avail = !pceFileOpen(&fa, pgl->game->fname, FOMD_RD);
		if(pgl->avail) pceFileClose(&fa);
	}

	/* ROMZbgt@CIB */
	sel = 0;
	for(;;) {
		for(;;) {
			schedule();

			if(joy & (TRG_A | TRG_START )) break;
			if(joy & (TRG_B | TRG_SELECT)) exit(0);
			if((joy & TRG_UP) && (sel > 0)) sel--;
			if((joy & TRG_DN) && (sel < NUM_GAMES - 1)) sel++;

			surface_clear(&surface, 0);
			for(i = 0; i < NUM_GAMES; i++) {
				pgl = &gamelist[i];
				color = pgl->avail ? 2 : 1;
				if(i == sel) color = 3;
				render_string(&render,
					1, 1 + i * 10,
					pgl->game->title,
					0x80, color);
			}
		}

		schedule();

		/* G~[VsB */
		pgl = &gamelist[sel];
		if(pgl->avail) emu_main(pgl->game);
	}
}
